// Copyright (c) 2016, root ext. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import '../lib/dna.dart';
import 'dart:io' as io;

@Lib('libc.so.6')
class Libc {
  dynamic lib = new DynamicLibrary<Libc>();

  int getpid() { return lib.getpid(); }
  int getuid() { return lib.getuid(); }
  int getgroups (int count, @Arg(ARG_LISTINT) Ref<List<int>> groups) { return lib.getgroups(count, groups); }

  int rand() { return lib.rand(); }
  int rand_r(@Arg(ARG_POINTER) seedp) { return lib.rand_r(seedp); }
  void srand(@Arg(ARG_INT) int seed) { return lib.srand(seed); }
}

void main(){
  Libc libc = new Libc();
  var processId = libc.getpid();
  print('pid $processId = ${io.pid}');

  var userId = libc.getuid();
  print('userId ${userId}');

  libc.srand(123456789);
  var rand = libc.rand();
  print('rand $rand');

  Ref<int> seed = new Ref<int>(123456789);
  var srand = libc.rand_r(seed);
  print('srand $srand');

}
