// Copyright (c) 2016, root ext. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

/// Dart Native Access
library dna;

import 'dart-ext:dna';
import 'dart:typed_data';
import 'dart:mirrors';

part 'pointer.dart';
part 'library.dart';

int nCreateCallVM(int size) native "nCreateCallVM";
void nFreeCallVM(int vm) native "nFreeCallVM";

void nArgBool(int vm, bool value) native "nArgBool";
void nArgChar(int vm, int value) native "nArgChar";
void nArgShort(int vm, int value) native "nArgShort";
void nArgInt(int vm, int value) native "nArgInt";
void nArgLong(int vm, int value) native "nArgLong";
void nArgLongLong(int vm, int value) native "nArgLongLong";
void nArgFloat(int vm, double value) native "nArgFloat";
void nArgDouble(int vm, double value) native "nArgDouble";
void nArgPointer(int vm, int pointer) native "nArgPointer";

void nArgPointerDart(int vm, Pointer pointer) native "nArgPointerDart";
void nArgString(int vm, String value) native "nArgString";
void nArgTypedData(int vm, TypedData value) native "nArgTypedData";
void nArgListString(int vm, List<String> value) native "nArgListString";
void nArgListInt(int vm, List<int> value) native "nArgListInt";

bool nCallBool(int vm, int pointer) native "nCallBool";
int nCallChar(int vm, int pointer) native "nCallChar";
int nCallShort(int vm, int pointer) native "nCallShort";
int nCallInt(int vm, int pointer) native "nCallInt";
int nCallLong(int vm, int pointer) native "nCallLong";
int nCallLongLong(int vm, int pointer) native "nCallLongLong";
int nCallPointer(int vm, int pointer) native "nCallPointer";
void nCallVoid(int vm, int pointer) native "nCallVoid";

String nCallString(int vm, int pointer) native "nCallString";
TypedData nCallTypedData(int vm, int pointer) native "nCallTypedData";

int nDefineStruct(String signature) native "nDefineStruct";
int nBuildStruct(String signature, List<Object> args) native "nBuildStruct";
void nArgStruct(int vm, int struct, int pointer) native "nArgStruct";
int nCallStruct(int vm, int pointer, int struct) native "nCallStruct";

int nLoadLibrary(String name) native "nLoadLibrary";
void nFreeLibrary(int lib) native "nFreeLibrary";
int nFindSymbol(int lib, String name) native "nFindSymbol";

Pointer loadLibrary(String name){
  return new Pointer(nLoadLibrary(name));
}

Pointer findSymbol(Pointer lib, String name){
  return new Pointer(nFindSymbol(lib.value, name));
}

void freeLibrary(Pointer lib){
  nFreeLibrary(lib.value);
}
